#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ncurses/ncurses.h>
#include <sys/io.h>
#include <string>
#include "colors.h"
#include "convert.h"
#include "info.h"
#include "open.h"

using namespace std;

void info()
{
	char binary378[80];
	char binary379[80];
	char binary37A[80];
	char button;
	int send;
	refresh();
	move(0,0);
	colors();
	printw("status on 0x378: %d\t", inb(read378));
      printw("status on 0x379: %d\t", inb(read379)-7);
      printw("status on 0x37A: %d\n", inb(read37A)-192);
      int decimal=inb(read378);
      dec2bin(decimal, binary378, 8, 7);
      decimal=inb(read379);
	dec2bin(decimal, binary379, 5, 7);
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 5, 4);
//      printw("%s",binary);
string a(binary378);
string tmp;
for(int i = 0; i<strlen(a.c_str()); i++) {
tmp.append( 1,a.at(i) );
if(i != strlen(a.c_str())-1)
tmp.append(1,'\t');
}

string b(binary379);
string tmp1;
for(int i = 0; i<strlen(b.c_str()); i++) {
tmp1.append( 1,b.at(i) );
if(i != strlen(b.c_str())-1)
tmp1.append(1,'\t');
}

string c(binary37A);
string tmp2;
for(int i = 0; i<strlen(c.c_str()); i++) {
tmp2.append( 1,c.at(i) );
if(i != strlen(c.c_str())-1)
tmp2.append(1,'\t');
}

//bin status
move(2,0);
printw("binary status on 0x378 with pin number:\n");
printw("9\t8\t7\t6\t5\t4\t3\t2\t<== pin number\n");
attron(COLOR_PAIR(2));
printw("%s\n\n",tmp.c_str());
attroff(COLOR_PAIR(2));
printw("binary status on 0x379 with pin number:\n");
printw("11\t10\t12\t13\t15\t<== pin number\n");
attron(COLOR_PAIR(1));
printw("%s\n\n",tmp1.c_str());
attroff(COLOR_PAIR(1));
printw("binary status on 0x37A with pin number:\n");
printw("-\t17\t16\t14\t1\t<== pin number\n");
attron(COLOR_PAIR(2));
printw("%s\n",tmp2.c_str());
attroff(COLOR_PAIR(2));
//
//change state
//

printw("\nto change state on 0x378, press 1-8 button (1 is eldest bit)\n");
printw("\nto change state on 0x37A, press q-t button (q is eldest bit)\n");
button = getch();
if(button==49)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 7);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +128;
		outb(send, read378);
	} else {
		send = inb(read378) -128;
		outb(send, read378);
	}
}
if(button==50)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 6);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +64;
		outb(send, read378);
	} else {
		send = inb(read378) -64;
		outb(send, read378);
	}
}
if(button==51)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 5);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +32;
		outb(send, read378);
	} else {
		send = inb(read378) -32;
		outb(send, read378);
	}
}
if(button==52)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 4);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +16;
		outb(send, read378);
	} else {
		send = inb(read378) -16;
		outb(send, read378);
	}
}
if(button==53)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 3);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +8;
		outb(send, read378);
	} else {
		send = inb(read378) -8;
		outb(send, read378);
	}
}
if(button==54)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 2);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +4;
		outb(send, read378);
	} else {
		send = inb(read378) -4;
		outb(send, read378);
	}
}
if(button==55)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 1);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +2;
		outb(send, read378);
	} else {
		send = inb(read378) -2;
		outb(send, read378);
	}
}
if(button==56)
{
	decimal=inb(read378);
	dec2bin(decimal, binary378, 1, 0);
	if (strcmp ( binary378, "0" ) == 0)
	{
		send = inb(read378) +1;
		outb(send, read378);
	} else {
		send = inb(read378) -1;
		outb(send, read378);
	}
}

//
// changing 0x37A state
//

if(button==113) // q
{
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 1, 4);
	if (strcmp ( binary37A, "0" ) == 0)
	{
		send = inb(read37A) +16;
		outb(send, read37A);
	} else {
		send = inb(read37A) -16;
		outb(send, read37A);
	}
}
if(button==119) // w
{
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 1, 3);
	if (strcmp ( binary37A, "0" ) == 0)
	{               
		send = inb(read37A) +8;
		outb(send, read37A);
	} else {
		send = inb(read37A) -8;
		outb(send, read37A);
	}
}
if(button==101) // e
{
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 1, 2);
	if (strcmp ( binary37A, "0" ) == 0)
	{               
		send = inb(read37A) +4;
		outb(send, read37A);
	} else {
		send = inb(read37A) -4;
		outb(send, read37A);
	}
}
if(button==114) // r
{
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 1, 1);
	if (strcmp ( binary37A, "0" ) == 0)
	{               
		send = inb(read37A) +2;
		outb(send, read37A);
	} else {
		send = inb(read37A) -2;
		outb(send, read37A);
	}
}
if(button==116) // t
{
	decimal=inb(read37A);
	dec2bin(decimal, binary37A, 1, 0);
	if (strcmp ( binary37A, "0" ) == 0)
	{               
		send = inb(read37A) +1;
		outb(send, read37A);
	} else {
		send = inb(read37A) -1;
		outb(send, read37A);
	}
}	
}

